"{ Package: 'stx:libtool2' }"

"{ NameSpace: Tools }"

ApplicationModel subclass:#InternationalLanguageTranslationEditor
	instanceVariableNames:'languagesList keyStringsToLanguageMappings languageTextHolder
		originalTextHolder modified shownLanguages selectedKeyRow
		showMissingTranslationsOnly
		keyStringAndLanguageSelectionTableColumnDescriptionHolder
		languageShownHolders dataSetView lastExtractedClass
		lastExtractedApplicationClass stopApplicationIconVisibleHolder
		monitoredApplication originalTextModifiedHolder
		languageTextModifiedHolder languageTextAcceptHolder
		inSingleFileMode lastExtractedProject lastLanguage
		lastSelectedKey autoAccept languageEditor selectedColIndexHolder'
	classVariableNames:'LastExtractedClass LastExtractedApplicationClass
		LastExtractedProject'
	poolDictionaries:''
	category:'Interface-UIPainter'
!

Object subclass:#AccessCollectingPseudoResourcePack
	instanceVariableNames:'collectedKeys realResourcePack'
	classVariableNames:''
	poolDictionaries:''
	privateIn:InternationalLanguageTranslationEditor
!

Collection subclass:#KeyStringsToLanguageMappings
	instanceVariableNames:'keys keyInfo perLanguageInfo perLanguageMappings languageMappings
		languages rowPerKey'
	classVariableNames:''
	poolDictionaries:''
	privateIn:InternationalLanguageTranslationEditor
!

Object subclass:#LanguageMappingRow
	instanceVariableNames:'key mappings'
	classVariableNames:''
	poolDictionaries:''
	privateIn:InternationalLanguageTranslationEditor
!

Visitor subclass:#UISpecVisitor
	instanceVariableNames:'translatedLabels'
	classVariableNames:''
	poolDictionaries:''
	privateIn:InternationalLanguageTranslationEditor
!

!InternationalLanguageTranslationEditor class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    [author:]
        cg (cg@FUSI)

    [instance variables:]

    [class variables:]

    [see also:]

"
!

examples
"
  Starting the application:
                                                                [exBegin]
    InternationalLanguageTranslationEditor open

                                                                [exEnd]

  more examples to be added:
                                                                [exBegin]
    ... add code fragment for 
    ... executable example here ...
                                                                [exEnd]
"
!

history
    "Created: / 04-03-2006 / 09:07:19 / cg"
! !

!InternationalLanguageTranslationEditor class methodsFor:'interface specs'!

windowSpec
    "This resource specification was automatically generated
     by the UIPainter of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the UIPainter may not be able to read the specification."

    "
     UIPainter new openOnClass:Tools::InternationalLanguageTranslationEditor andSelector:#windowSpec
     Tools::InternationalLanguageTranslationEditor new openInterface:#windowSpec
     Tools::InternationalLanguageTranslationEditor open
    "

    <resource: #canvas>

    ^ 
     #(FullSpec
        name: windowSpec
        window: 
       (WindowSpec
          label: 'InternationalLanguageTranslationEditor'
          name: 'InternationalLanguageTranslationEditor'
          min: (Point 10 10)
          max: (Point 1024 768)
          bounds: (Rectangle 0 0 636 396)
          menu: mainMenu
        )
        component: 
       (SpecCollection
          collection: (
           (MenuPanelSpec
              name: 'ToolBar'
              layout: (LayoutFrame 0 0 0 0 0 1 30 0)
              menu: menuToolBar
              textDefault: true
            )
           (VariableVerticalPanelSpec
              name: 'VariableVerticalPanel1'
              layout: (LayoutFrame 0 0 30 0 0 1 0 1)
              component: 
             (SpecCollection
                collection: (
                 (DataSetSpec
                    name: 'KeyStringAndLanguageSelectionTable'
                    model: selectedKeyRow
                    hasHorizontalScrollBar: true
                    hasVerticalScrollBar: true
                    dataList: keyStringAndLanguageSelectionTable
                    columnHolder: keyStringAndLanguageSelectionTableColumnDescriptionHolder
                    beDependentOfRows: true
                    columnAdaptor: yourself
                    postBuildCallback: postBuildDataSet:
                  )
                 (ViewSpec
                    name: 'Box1'
                    component: 
                   (SpecCollection
                      collection: (
                       (LabelSpec
                          label: 'Original String (Key):'
                          name: 'Label2'
                          layout: (LayoutFrame 0 0 0 0 0 1 30 0)
                          translateLabel: true
                          adjust: left
                        )
                       (TextEditorSpec
                          name: 'OriginalText'
                          layout: (LayoutFrame 0 0 30 0 0 1 0 1)
                          model: originalTextHolder
                          hasHorizontalScrollBar: true
                          hasVerticalScrollBar: true
                          modifiedChannel: originalTextModifiedHolder
                        )
                       )
                     
                    )
                  )
                 (ViewSpec
                    name: 'Box2'
                    component: 
                   (SpecCollection
                      collection: (
                       (LabelSpec
                          label: 'Translated String:'
                          name: 'Label1'
                          layout: (LayoutFrame 0 0 0 0 0 1 30 0)
                          translateLabel: true
                          adjust: left
                        )
                       (TextEditorSpec
                          name: 'LanguageText'
                          layout: (LayoutFrame 0 0 30 0 0 1 0 1)
                          model: languageTextHolder
                          hasHorizontalScrollBar: true
                          hasVerticalScrollBar: true
                          acceptChannel: languageTextAcceptHolder
                          modifiedChannel: languageTextModifiedHolder
                          postBuildCallback: languageEditorBuilt:
                        )
                       )
                     
                    )
                  )
                 )
               
              )
              handles: (Any 0.33333333333333 0.66666666666667 1.0)
            )
           )
         
        )
      )
! !

!InternationalLanguageTranslationEditor class methodsFor:'menu specs'!

mainMenu
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:InternationalLanguageTranslationEditor andSelector:#mainMenu
     (Menu new fromLiteralArrayEncoding:(InternationalLanguageTranslationEditor mainMenu)) startUp
    "

    <resource: #menu>

    ^ 
     #(Menu
        (
         (MenuItem
            label: 'File'
            translateLabel: true
            submenu: 
           (Menu
              (
               (MenuItem
                  label: 'New'
                  itemValue: menuNew
                  translateLabel: true
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Open Resource File...'
                  itemValue: menuOpen
                  translateLabel: true
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Save Resource File'
                  itemValue: menuSave
                  translateLabel: true
                )
               (MenuItem
                  label: 'Save Resource File As...'
                  itemValue: menuSaveAs
                  translateLabel: true
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Exit'
                  itemValue: closeRequest
                  translateLabel: true
                )
               )
              nil
              nil
            )
          )
         (MenuItem
            label: 'View'
            translateLabel: true
            submenu: 
           (Menu
              (
               (MenuItem
                  label: 'Show Missing Translations Only'
                  translateLabel: true
                  indication: showMissingTranslationsOnly
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Shown Languages'
                  translateLabel: true
                  submenuChannel: shownLanguagesMenu
                )
               )
              nil
              nil
            )
          )
         (MenuItem
            label: 'Languages'
            translateLabel: true
            submenu: 
           (Menu
              (
               (MenuItem
                  label: 'Add Language...'
                  itemValue: addLanguage
                  translateLabel: true
                )
               (MenuItem
                  label: 'Remove Language...'
                  itemValue: removeLanguage
                  translateLabel: true
                )
               )
              nil
              nil
            )
          )
         (MenuItem
            label: 'Translations'
            translateLabel: true
            submenu: 
           (Menu
              (
               (MenuItem
                  label: 'Add Translation...'
                  itemValue: addTranslation
                  translateLabel: true
                )
               (MenuItem
                  label: 'Remove Translation...'
                  itemValue: removeTranslation
                  translateLabel: true
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Extract from Class...'
                  itemValue: extractTranslationsFromClass
                  translateLabel: true
                )
               (MenuItem
                  label: 'Extract from Project...'
                  itemValue: extractTranslationsFromProject
                  translateLabel: true
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'Run Application and Collect Translations...'
                  itemValue: runApplicationAndCollectTranslations
                  translateLabel: true
                )
               )
              nil
              nil
            )
          )
         (MenuItem
            label: 'Help'
            translateLabel: true
            startGroup: right
            submenu: 
           (Menu
              (
               (MenuItem
                  label: 'Documentation'
                  itemValue: openDocumentation
                  translateLabel: true
                )
               (MenuItem
                  label: '-'
                )
               (MenuItem
                  label: 'About this Application...'
                  itemValue: openAboutThisApplication
                  translateLabel: true
                )
               )
              nil
              nil
            )
          )
         )
        nil
        nil
      )
!

menuToolBar
    "This resource specification was automatically generated
     by the MenuEditor of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the MenuEditor may not be able to read the specification."

    "
     MenuEditor new openOnClass:InternationalLanguageTranslationEditor andSelector:#menuToolBar
     (Menu new fromLiteralArrayEncoding:(InternationalLanguageTranslationEditor menuToolBar)) startUp
    "

    <resource: #menu>

    ^ 
     #(Menu
        (
         (MenuItem
            label: 'Save'
            translateLabel: true
            labelImage: (ResourceRetriever XPToolbarIconLibrary saveImageIcon)
          )
         (MenuItem
            label: '-'
          )
         (MenuItem
            label: 'Add Translation'
            itemValue: addTranslation
            translateLabel: true
            labelImage: (ResourceRetriever XPToolbarIconLibrary newRowIcon)
          )
         (MenuItem
            label: 'Remove Translation'
            itemValue: removeTranslation
            translateLabel: true
            labelImage: (ResourceRetriever XPToolbarIconLibrary removeRowIcon)
          )
         (MenuItem
            label: ''
          )
         (MenuItem
            label: 'Stop Application'
            itemValue: stopApplication
            translateLabel: true
            isVisible: stopApplicationIconVisibleHolder
            labelImage: (ResourceRetriever XPToolbarIconLibrary stop16x16Icon)
          )
         )
        nil
        nil
      )
! !

!InternationalLanguageTranslationEditor class methodsFor:'tableColumns specs'!

keyTableColumn
    "This resource specification was automatically generated
     by the DataSetBuilder of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the DataSetBuilder may not be able to read the specification."

    "
     DataSetBuilder new openOnClass:Tools::InternationalLanguageTranslationEditor andSelector:#keyTableColumn
    "

    <resource: #tableColumns>

    ^#(
      (DataSetColumnSpec
         label: 'Key'
         labelButtonType: Button
         minWidth: 50
         model: keyStringInRow:
       )
      )
!

languageTableColumn
    "This resource specification was automatically generated
     by the DataSetBuilder of ST/X."

    "Do not manually edit this!! If it is corrupted,
     the DataSetBuilder may not be able to read the specification."

    "
     DataSetBuilder new openOnClass:Tools::InternationalLanguageTranslationEditor andSelector:#languageTableColumn
    "

    <resource: #tableColumns>

    ^#(
      (DataSetColumnSpec
         label: lang
         labelButtonType: Button
         minWidth: 50
         editorType: None
         model: columnInRow:at:
         backgroundSelector: getBackgroundForRow:rowNr:col:
       )
      )
! !

!InternationalLanguageTranslationEditor methodsFor:'accessing'!

autoAccept
    autoAccept isNil ifTrue:[autoAccept := true].
    ^ autoAccept
!

autoAccept:something
    autoAccept := something.
!

newLanguageText
"/   languageEditor accept
^self languageTextHolder value isNil 
    ifTrue:['']
    ifFalse:[self languageTextHolder value asCollectionOfLines first.]
! !

!InternationalLanguageTranslationEditor methodsFor:'aspects'!

keyStringAndLanguageSelectionTable
    keyStringsToLanguageMappings isNil ifTrue:[
        keyStringsToLanguageMappings := KeyStringsToLanguageMappings new.
    ].
    ^ keyStringsToLanguageMappings.
!

keyStringAndLanguageSelectionTableColumnDescriptionHolder
    keyStringAndLanguageSelectionTableColumnDescriptionHolder isNil ifTrue:[
        keyStringAndLanguageSelectionTableColumnDescriptionHolder := ValueHolder new.
        keyStringAndLanguageSelectionTableColumnDescriptionHolder value:(self keyStringAndLanguageSelectionTableColumnDescription).
    ].
    ^ keyStringAndLanguageSelectionTableColumnDescriptionHolder.
!

languageAtCol:colNr
    ^ shownLanguages at:colNr-1.
!

languageShownHolderFor:lang
    |holder|

    languageShownHolders isNil ifTrue:[
        languageShownHolders := Dictionary new
    ].
    holder := languageShownHolders 
                at:lang 
                ifAbsentPut:[ 
                    |h|

                    h := true asValue.
                    h onChangeEvaluate:[ 
                        h value ifTrue:[
                           self enableLanguageDisplayFor:lang     
                        ] ifFalse:[
                           self disableLanguageDisplayFor:lang     
                        ].
                    ].
                    h
                ].
    ^ holder.
!

languageTextAcceptHolder
    languageTextAcceptHolder isNil ifTrue:[
        languageTextAcceptHolder := false asValue.
        languageTextAcceptHolder onChangeSend:#languageTextAccepted to:self.
    ].
    ^ languageTextAcceptHolder.
!

languageTextAccepted       
                                         "
self updateLanguageTextModification.    "
self selectedKeyRow value: self selectedKeyRow value + 1.
!

languageTextHolder
    languageTextHolder isNil ifTrue:[
        languageTextHolder := '' asValue.
    ].
    ^ languageTextHolder.
!

languageTextModifiedHolder
    languageTextModifiedHolder isNil ifTrue:[
        languageTextModifiedHolder := false asValue.
    ].
    ^ languageTextModifiedHolder.
!

languagesList
    languagesList isNil ifTrue:[
        languagesList := List withAll:(self keyStringAndLanguageSelectionTable languages).
    ].
    ^ languagesList.
!

originalTextHolder
    originalTextHolder isNil ifTrue:[
        originalTextHolder := '' asValue.
    ].
    ^ originalTextHolder.
!

originalTextModifiedHolder
    originalTextModifiedHolder isNil ifTrue:[
        originalTextModifiedHolder := false asValue.
    ].
    ^ originalTextModifiedHolder.
!

selectedKeyRow
    selectedKeyRow isNil ifTrue:[
        selectedKeyRow := ValueHolder new.
        selectedKeyRow onChangeSend:#selectionChanged to:self.
    ].
    ^ selectedKeyRow.
!

showMissingTranslationsOnly
    showMissingTranslationsOnly isNil ifTrue:[
        showMissingTranslationsOnly := false asValue.
    ].
    ^ showMissingTranslationsOnly.
!

shownLanguages
    shownLanguages isNil ifTrue:[
        shownLanguages := List new.
        shownLanguages addAll:(self languagesList).
        shownLanguages onChangeSend:#shownLanguagesChanged to:self.
    ].
    ^ shownLanguages.
!

stopApplicationIconVisibleHolder
    stopApplicationIconVisibleHolder isNil ifTrue:[
        stopApplicationIconVisibleHolder := false asValue.
    ].
    ^ stopApplicationIconVisibleHolder.
!

updateLanguageAndKeySelection

    |rowSelectionIndex colSelectionIndex language selectedKey originalText languageText|

    colSelectionIndex := dataSetView selectedColIndex.
    language := colSelectionIndex > 1 ifTrue:[ shownLanguages at:colSelectionIndex-1 ] ifFalse:nil.

    rowSelectionIndex := self selectedKeyRow value.
    rowSelectionIndex ~~ 0 ifTrue:[
        selectedKey := keyStringsToLanguageMappings keyAt:rowSelectionIndex.
        originalText := selectedKey storeString.
        language notNil ifTrue:[
            languageText := keyStringsToLanguageMappings at:selectedKey language:language.
            languageText notNil ifTrue:[
                languageText := languageText storeString.
            ]
        ]
    ].              
    self originalTextHolder value:originalText.
    self languageTextHolder value:languageText.
    lastLanguage := language.
    lastSelectedKey := selectedKey. 
! !

!InternationalLanguageTranslationEditor methodsFor:'change & update'!

update:something with:aParameter from:changedObject
    changedObject == shownLanguages ifTrue:[
         self shownLanguagesChanged.
         ^ self.
    ].
    changedObject == languageTextAcceptHolder ifTrue:[
         self updateLanguageTextModification.
         ^ self.
    ].
!

updateKeyStringsToLanguageMappings           

      keyStringsToLanguageMappings 
        at:lastSelectedKey 
        language:lastLanguage 
        put: self newLanguageText.
!

updateLanguageTextModification 
     self languageTextModifiedHolder value ifTrue:[ 
        (self autoAccept or:[Dialog confirm:'Accept changed translation ?']) ifTrue:[
            self languageTextModifiedHolder value:false.
            self languageTextHolder value:languageEditor contents.
            lastLanguage notNil ifTrue:[self updateKeyStringsToLanguageMappings.]
        ]
    ].
!

updateOriginalTextModification

|answer|

    self originalTextModifiedHolder value ifTrue:[ 
        answer := OptionBox 
                      request:'Accept changed original text (key) ?' 
                      label:'Original text (key) changed'
                      image:(WarningBox iconBitmap)
                      buttonLabels:#('Cancel' 'Accept' 'Accept As New')
                      values:#(nil #accept #acceptAsNew)
                      default:#acceptAsNew.

        answer isNil ifTrue:[^ self originalTextModifiedHolder value:false. ].
        answer == #accept ifTrue:[
self halt.        ].
        answer == #acceptAsNew ifTrue:[
self halt.        ].
    ].
! !

!InternationalLanguageTranslationEditor methodsFor:'initialization & release'!

closeRequest
    "asks for permission before closing"

    self hasUnsavedChanges ifTrue:[
        (Dialog 
            confirm:(resources string:'Close without saving ?')
            default:false) ifFalse:[
            ^ self
        ]
    ].

    super closeRequest
!

initialize
    modified := false.
    inSingleFileMode := false.
    super initialize
!

languageEditorBuilt:aView
    languageEditor := aView.
!

postBuildDataSet:aView
    dataSetView := aView.
    aView selectedColIndexHolder onChangeSend:#selectionChanged to:self.
! !

!InternationalLanguageTranslationEditor methodsFor:'menu actions'!

addLanguage
    |lang|

    lang := Dialog request:'New language (ISO symbol):'.
    lang isEmptyOrNil ifTrue:[^ self].

    (keyStringsToLanguageMappings includesLanguage:lang) ifTrue:[^ self ].

    keyStringsToLanguageMappings addLanguage:lang.
    self languagesList add:lang.
    self shownLanguages add:lang.
    modified := true.
!

addTranslation
    |key index|

    key := Dialog request:'New Key:'.
    (keyStringsToLanguageMappings includesKey:key) ifFalse:[
        keyStringsToLanguageMappings addKey:key.
        modified := true.
    ].
    index := keyStringsToLanguageMappings indexOfKey:key.

    self selectedKeyRow value:index
!

extractTranslationsFromClass
    |aClass newTranslations|

    aClass := Dialog 
                requestClass:'Class to extract translations from:'
                okLabel:'OK' 
                initialAnswer:(lastExtractedClass ? LastExtractedClass).
    aClass isNil ifTrue:[^ self ].

    lastExtractedClass := LastExtractedClass := aClass.

    newTranslations := self extractTranslationsFromClass:aClass.
    self addAllTranslations:newTranslations.
!

extractTranslationsFromProject
    |box projectID newTranslations|

    box := ListSelectionBox new.
"/    box useComboBoxWithList:(Smalltalk allProjectIDs).
    box title:(resources string:'Project to extract translations from:').
    box list:Smalltalk allProjectIDs.
    box okAction:[:sel | projectID := sel].
    box initialText:(lastExtractedProject ? LastExtractedProject).
    box label:'Find Translations in Project'.

    box showAtPointer.

    projectID notNil ifTrue:[
        projectID := projectID withoutSeparators asSymbol.
    ].
    projectID isEmptyOrNil ifTrue:[^ self ].

    lastExtractedProject := LastExtractedProject := projectID.

    newTranslations := Set new.

    Smalltalk allClassesDo:[:eachClass |
        eachClass theNonMetaclass package == projectID ifTrue:[
"/ eachClass isLoaded ifTrue:[ self halt. ].
            newTranslations addAll:( self extractTranslationsFromClass:eachClass theNonMetaclass).
        ]
    ].

    self addAllTranslations:newTranslations.
!

menuNew
    modified ifTrue:[
        (Dialog 
            confirm:(resources stringWithCRs:'Modified translations have not been changed.\\Create new translations set anyway ?')
            default:false) ifFalse:[^ self].
    ].

    keyStringsToLanguageMappings initialize.
    keyStringsToLanguageMappings changed.

    self languagesList contents:self keyStringAndLanguageSelectionTable languages.
    self shownLanguages contents:self keyStringAndLanguageSelectionTable languages.
    modified := false.
!

menuOpen
    |fn|

    fn := Dialog 
        requestFileName:'Name of resource file:'
        default:nil 
        pattern:'*.rs'.

    fn isEmptyOrNil ifTrue:[^ self ].
    fn := fn asFilename.
    fn exists ifFalse:[^ self ].

    self readResourceFile:fn
!

menuSave
    "This method was generated by the Browser.
     It will be invoked when the menu-item 'save' is selected."

    "/ change below and add any actions as required here ...
    self warn:'no action for ''save'' available.'.
!

menuSaveAs
    "This method was generated by the Browser.
     It will be invoked when the menu-item 'saveAs' is selected."

    "/ change below and add any actions as required here ...
    self warn:'no action for ''saveAs'' available.'.
!

openAboutThisApplication
    "This method was generated by the Browser.
     It will be invoked when the menu-item 'help-about' is selected."

    "/ could open a customized aboutBox here ...
    super openAboutThisApplication
!

openDocumentation
    "This method was generated by the Browser.
     It will be invoked when the menu-item 'help-documentation' is selected."

    "/ change below as required ...

    "/ to open an HTML viewer on some document (under 'doc/online/<language>/' ):
    HTMLDocumentView openFullOnDocumentationFile:'TOP.html'.

    "/ add application-specific help files under the 'doc/online/<language>/help/appName'
    "/ directory, and open a viewer with:
    "/ HTMLDocumentView openFullOnDocumentationFile:'help/<MyApplication>/TOP.html'.
!

readResourceFile:aFilename
    |lang|

    lang := Dialog choose:'For which language ?' fromList:languagesList lines:10.
    lang isNil ifTrue:[^ self ].

    self readResourceFile:aFilename asLanguage:lang asSymbol
!

readResourceFile:aFilename asLanguage:lang
    |resourcePack inStream lineString encoding decoder sortedKeys remainingKeys|

    aFilename exists ifFalse:[^ self ].

    resourcePack := ResourcePack new.

    inStream := aFilename readStream.
    [inStream atEnd] whileFalse:[
        lineString := inStream nextLine.
        (lineString notEmpty 
        and:[ (lineString startsWith:';') not ]) ifTrue:[
            ((lineString startsWith:'#') and:[(lineString startsWith:'#(') not]) ifTrue:[
                lineString := (lineString copyFrom:2) withoutSeparators.
                (lineString startsWith:'encoding ') ifTrue:[
                    encoding := ResourcePack extractEncodingFromLine:lineString.
                    decoder := CharacterEncoder encoderFor:encoding ifAbsent:nil.
                ].
            ] ifFalse:[
                ResourcePack
                    processResourceLine:lineString 
                    encoding:decoder 
                    file:aFilename pathName 
                    printErrorWith:[:msg | Transcript showCR:msg ] 
                    for:resourcePack
                    keepUselessTranslations:true.
            ].
        ].
    ].
    inStream close.

    sortedKeys := (resourcePack keys select:[:k | k isString]) asSortedCollection.
    remainingKeys := resourcePack keys select:[:k | k isString not].

    sortedKeys do:[:k |
        keyStringsToLanguageMappings at:k language:lang put:(resourcePack at:k)
    ].
    remainingKeys do:[:k |
        keyStringsToLanguageMappings at:k language:lang put:(resourcePack at:k)
    ].
!

removeLanguage
    "automatically generated by UIEditor ..."

    "*** the code below performs no action"
    "*** (except for some feedback on the Transcript)"
    "*** Please change as required and accept in the browser."
    "*** (and replace this comment by something more useful ;-)"

    "action to be added ..."

    Transcript showCR:self class name, ': action for #removeLanguage ...'.
!

removeTranslation
    |rowSelectionIndex selectedKey|

    rowSelectionIndex := self selectedKeyRow value.
    rowSelectionIndex ~~ 0 ifTrue:[
        selectedKey := keyStringsToLanguageMappings keyAt:rowSelectionIndex ifAbsent:nil.
        (Dialog confirm:(resources string:'Really remove key %1' with:selectedKey)) ifTrue:[
            keyStringsToLanguageMappings removeKey:selectedKey.
        ].
    ].
!

runApplicationAndCollectTranslations
    |applicationClass newTranslations pseudoPack app startSelector|

    monitoredApplication notNil ifTrue:[
        monitoredApplication terminate.
        [monitoredApplication notNil] whileTrue:[
            Delay waitForSeconds:0.1
        ].
    ].

    applicationClass := Dialog 
                requestClass:'Application class to start and collect translations from:'
                okLabel:'OK' 
                initialAnswer:(lastExtractedApplicationClass ? LastExtractedApplicationClass ).
    applicationClass isNil ifTrue:[^ self ].
    applicationClass isNamespace ifTrue:[
        Dialog warn:'Entered class is a NameSpace'.
        ^ self.
    ].

    applicationClass isVisualStartable ifTrue:[
        startSelector := #open
    ] ifFalse:[
        startSelector := Dialog
                    request:'Entered class seems to be no application class. Ok to start using selector:'
                    initialAnswer:((applicationClass respondsTo:#'start')
                                        ifTrue:#'start'
                                        ifFalse:#'new')
                    okLabel:'START'
                    title:'Start Application'.
        startSelector isNil ifTrue:[
            ^ self
        ].
        startSelector := startSelector asSymbol.
    ].

    lastExtractedApplicationClass := LastExtractedApplicationClass := applicationClass.

    newTranslations := Set new.

    pseudoPack := AccessCollectingPseudoResourcePack new.
    pseudoPack realResourcePack:(applicationClass classResources).

    self stopApplicationIconVisibleHolder value:true.

    monitoredApplication := [
        [
            app := applicationClass new.
            app perform:startSelector.
            app window waitUntilVisible.
            app window waitUntilClosed.
        ] ensure:[
            app closeRequest.
            self stopApplicationIconVisibleHolder value:false.
            monitoredApplication := nil.
        ].
    ] fork.
! !

!InternationalLanguageTranslationEditor methodsFor:'menus dynamic'!

disableLanguageDisplayFor:lang
    self shownLanguages remove:lang ifAbsent:[]
!

enableLanguageDisplayFor:newLang
    |shownLanguagesInOrder|

    (self shownLanguages includes:newLang) ifFalse:[
"/        shownLanguagesInOrder := self languagesList
"/                                    select:[:lang | (self shownLanguages includes:lang)
"/                                                    or:[ lang = newLang ]].
"/        self shownLanguages contents:shownLanguagesInOrder.
        self shownLanguages add:newLang.
    ]
!

isLanguageShown:lang
    ^ self shownLanguages includes:lang
!

shownLanguagesMenu
    <resource: #programMenu >

    ^ [
        |m selected|

        m := Menu new.

        self languagesList do:[:lang |
            |item|

            item := MenuItem label:lang.
            item indication:(self languageShownHolderFor:lang).
            item hideMenuOnActivated:false.    
            m addItem:item.
        ].
        m
    ].
!

toggleLanguageDisplayFor:lang
    (self shownLanguages includes:lang) ifTrue:[
        self disableLanguageDisplayFor:lang
    ] ifFalse:[
        self enableLanguageDisplayFor:lang
    ].
! !

!InternationalLanguageTranslationEditor methodsFor:'private-key extraction'!

addAllTranslations:newTranslations
    |newTranslationKeys stringKeys nonStringKeys|

    newTranslationKeys := newTranslations select:[:k | k notEmpty and:[k isString not or:[k isBlank not]]].
    newTranslationKeys := newTranslationKeys select:[:k | (keyStringsToLanguageMappings includesKey:k) not].
    newTranslationKeys := newTranslationKeys 
                                collect:[:k | 
                                        (k endsWith:'...') ifTrue:[
                                            k copyWithoutLast:3.
                                        ] ifFalse:[
                                            ('.:?' includes:k last) ifTrue:[
                                                k copyWithoutLast:1.
                                            ] ifFalse:[
                                                k
                                        ]]].
    newTranslationKeys := newTranslationKeys asSet.

    newTranslationKeys notEmpty ifTrue:[
        stringKeys := newTranslationKeys select:[:k | k isString].
        nonStringKeys := newTranslationKeys select:[:k | k isString not].

        stringKeys := stringKeys asSortedCollection.
        keyStringsToLanguageMappings addKeys:stringKeys.
        keyStringsToLanguageMappings addKeys:nonStringKeys.
        modified := true.
    ].
!

extractTranslationsFromClass:aClass
    |newTranslations|

    newTranslations := Set new.

    self withWaitCursorDo:[
        "/ now, the hard part:
        "/ possible translations are in the specs,
        "/ and all arguments to (resources string:) messages.
        aClass instAndClassMethodsDo:[:eachMethod |
            newTranslations addAll:( self extractTranslationsFromMethod:eachMethod ).
        ].
    ].
    ^ newTranslations
!

extractTranslationsFromHelpSpecMethod:aMethod
    |codeStrings matcher parseTree resourceKeys|

    parseTree := RBParser 
            parseMethod:aMethod source 
            onError: [:str :pos | Transcript showCR:str. Transcript showCR:pos.
                                  nil].
    parseTree isNil ifTrue:[^ #() ].

    codeStrings  := 
        #(
                '`@dict addPairsFrom: `#helpKeysAndStrings'
        ).

    resourceKeys := Set new.

    matcher := ParseTreeSearcher new.
    matcher 
        matchesAnyOf: codeStrings 
        do: [:aNode :answer |
                |sel argNode arg|

                sel := aNode selector.
                (sel startsWith:'addPairsFrom:') ifTrue:[
                    argNode := aNode arguments at:1.
                    argNode isLiteral ifTrue:[
                        arg := argNode value.
                        arg isArray ifTrue:[
                            arg doWithIndex:[:el :index |
                                index even ifTrue:[
                                    el isString ifTrue:[    
                                        resourceKeys add:el.
                                    ]
                                ].
                            ].
                        ] ifFalse:[
                            Transcript 
                                showCR:(resources 
                                        string:'Cannot derive resourceKey from non-array in %1 in %2'
                                        with:argNode formattedCode
                                        with:aMethod selector).
                        ].
                    ] ifFalse:[
                        Transcript 
                            showCR:(resources 
                                        string:'Cannot derive resourceKey from non-literal: %1 in %2'
                                        with:argNode formattedCode
                                        with:aMethod selector).
                    ].
                ].
                aNode
            ].

    matcher executeTree: parseTree initialAnswer: nil.
    ^ resourceKeys
!

extractTranslationsFromMenuSpecMethod:aMethod
    |menu resourceKeys|

    menu := aMethod mclass theNonMetaclass perform:aMethod selector.
    menu isNil ifTrue:[ ^ #() ].

    (menu isKindOf:Menu) ifFalse:[
        menu := Menu new fromLiteralArrayEncoding:menu
    ].

    resourceKeys := Set new.
    menu allItemsDo:[:aMenuItem |
        aMenuItem translateLabel ifTrue:[
            aMenuItem isSeparatorItem ifFalse:[
                resourceKeys add:aMenuItem label.
            ]
        ]
    ].
    ^ resourceKeys
!

extractTranslationsFromMethod:aMethod
    |mResources|

    mResources := aMethod resources.
    mResources notNil ifTrue:[
        (mResources includesKey:#menu) ifTrue:[
             ^ self extractTranslationsFromMenuSpecMethod:aMethod.
        ].
        (mResources includesKey:#canvas) ifTrue:[
             ^ self extractTranslationsFromUISpecMethod:aMethod.
        ].
        (mResources includesKey:#help) ifTrue:[
             ^ self extractTranslationsFromHelpSpecMethod:aMethod.
        ].
        (mResources includesKey:#tableColumns) ifTrue:[
             ^ self extractTranslationsFromTableColumnsSpecMethod:aMethod.
        ].

        ^ self extractTranslationsFromSpecMethod:aMethod.
    ].
    ^ self extractTranslationsFromMethodsCode:aMethod
!

extractTranslationsFromMethodsCode:aMethod
"/method:mthd selector:sel inClass:cls matchesParseTreeMatcher:aMatcher
    |codeStrings matcher parseTree resourceKeys|

    parseTree := RBParser 
            parseMethod:aMethod source 
            onError: [:str :pos | Transcript showCR:str. Transcript showCR:pos.
                                  nil].
    parseTree isNil ifTrue:[^ #() ].

    codeStrings  := 
        #(
                'resources `@msg: `@args'
                'self resources `@msg: `@args'
                'self class resources `@msg: `@args'
                'self classResources `@msg: `@args'
        ).

    resourceKeys := Set new.

    matcher := ParseTreeSearcher new.
    matcher 
        matchesAnyOf: codeStrings 
        do: [:aNode :answer |
                |sel keyStringArgNode keyStringArg|

                sel := aNode selector.
                ((sel startsWith:'string:') or:[(sel startsWith:'at:')]) ifTrue:[
                    keyStringArgNode := aNode arguments at:1.
                    keyStringArgNode isLiteral ifTrue:[
                        keyStringArg := keyStringArgNode value.
                        keyStringArg isString ifTrue:[
                            resourceKeys add:keyStringArg.
                        ] ifFalse:[
                            Transcript 
                                showCR:(resources 
                                        string:'Cannot derive resourceKey from non-string: %1 in %2'
                                        with:keyStringArgNode formattedCode
                                        with:aMethod selector).
                        ].
                    ] ifFalse:[
                        Transcript 
                            showCR:(resources 
                                        string:'Cannot derive resourceKey from non-literal: %1 in %2'
                                        with:keyStringArgNode formattedCode
                                        with:aMethod selector).
                    ].
                ].
                aNode
            ].

    matcher executeTree: parseTree initialAnswer: nil.
    ^ resourceKeys
!

extractTranslationsFromSpecMethod:aMethod
    ^ #()
!

extractTranslationsFromTableColumnsSpecMethod:aMethod
    |columnDescription resourceKeys|

    columnDescription := aMethod mclass theNonMetaclass perform:aMethod selector.
    columnDescription isNil ifTrue:[ ^ #() ].

    (columnDescription first isKindOf:DataSetColumnSpec) ifFalse:[
        columnDescription := columnDescription collect:[:el | DataSetColumnSpec new fromLiteralArrayEncoding:el].
    ].

    resourceKeys := Set new.
    columnDescription do:[:aColumnSpec |
        aColumnSpec translateLabel ifTrue:[
            resourceKeys add:aColumnSpec label.
        ]
    ].
    ^ resourceKeys
!

extractTranslationsFromUISpecMethod:aMethod
    |spec resourceKeys visitor|

    spec := aMethod mclass theNonMetaclass perform:aMethod selector.
    spec isNil ifTrue:[ ^ #() ].

    (spec isKindOf:UISpecification) ifFalse:[
        spec := UISpecification from:spec
    ].

    resourceKeys := Set new.

    visitor := UISpecVisitor new.
    spec acceptVisitor:visitor.

    ^ visitor translatedLabels
! !

!InternationalLanguageTranslationEditor methodsFor:'queries'!

hasUnsavedChanges
    ^ modified
! !

!InternationalLanguageTranslationEditor methodsFor:'specs-dynamic'!

columnInRow:row at:colIndex
    |lang|

    lang := self languageAtCol:colIndex.
    ^ row atLanguage:lang
!

getBackgroundForRow:row rowNr:rowNr col:colIndex
    |lang|

    colIndex == 1 ifTrue:[^ nil].
    lang := self languageAtCol:colIndex.
    ^ (row atLanguage:lang) isNil ifTrue:[Color red lightened] ifFalse:nil
!

keyStringAndLanguageSelectionTableColumnDescription
    |spec|

    spec := OrderedCollection new.

    spec add:(self class keyTableColumn first).

    self shownLanguages do:[:lang |
        |entry|

        entry := self class languageTableColumn first.
        entry := entry copy replaceAll:#lang with:lang.
        spec add: entry 
    ].
    ^ spec
!

keyStringInRow:row
    ^ row keyString
! !

!InternationalLanguageTranslationEditor methodsFor:'user actions'!

selectionChanged                

   self updateOriginalTextModification.
   self updateLanguageTextModification.
   self updateLanguageAndKeySelection.

   self originalTextModifiedHolder value:false.
   self languageTextModifiedHolder value:false.
!

shownLanguagesChanged
    self keyStringAndLanguageSelectionTableColumnDescriptionHolder 
        value:(self keyStringAndLanguageSelectionTableColumnDescription).
!

stopApplication
    |p|

    (p := monitoredApplication) notNil ifTrue:[
        p terminate.
    ].
! !

!InternationalLanguageTranslationEditor::AccessCollectingPseudoResourcePack methodsFor:'accessing'!

realResourcePack:something
    realResourcePack := something.
! !

!InternationalLanguageTranslationEditor::KeyStringsToLanguageMappings class methodsFor:'instance creation'!

new
    ^ self basicNew initialize
! !

!InternationalLanguageTranslationEditor::KeyStringsToLanguageMappings methodsFor:'accessing'!

addKey:aKey
    (keys includes:aKey) ifFalse:[
        keys add:aKey.
        self changed.
    ]
!

addKeys:aCollectionOfKey
    keys addAll:aCollectionOfKey.
    self changed.
!

addLanguage:lang
    (languages includes:lang) ifFalse:[
        languages add:lang.
        perLanguageMappings at:lang put:(Dictionary new).
    ]
!

at:aKey language:language
    ^ (perLanguageMappings at:language) at:aKey ifAbsent:nil
!

at:aKey language:language put:value
    self addKey:aKey.
    (perLanguageMappings at:language) at:aKey put:value.
    (self rowForKey:aKey) changed
!

keyAt:index
    ^ keys at:index.
!

keyAt:index ifAbsent:exceptionalValue
    ^ keys at:index ifAbsent:exceptionalValue.
!

keys
    ^ keys
!

languages
    ^ languages
!

removeKey:aKey
    keys remove:aKey ifAbsent:[].
    perLanguageMappings do:[:eachMapping |
        eachMapping removeKey:aKey ifAbsent:[].
    ].
    self changed.
!

rowForKey:aKey
    ^ rowPerKey 
            at:aKey
            ifAbsentPut:[InternationalLanguageTranslationEditor::LanguageMappingRow new 
                            key:aKey; mappings:self].
!

size
    ^ keys size
! !

!InternationalLanguageTranslationEditor::KeyStringsToLanguageMappings methodsFor:'enumerating'!

do:aBlock
    keys do:[:eachKey |
        aBlock value:(self rowForKey:eachKey).
    ].
! !

!InternationalLanguageTranslationEditor::KeyStringsToLanguageMappings methodsFor:'initialization'!

initialize
    super initialize.

    keys := OrderedSet new.
    languages := OrderedCollection new.
    perLanguageMappings := Dictionary new.
    perLanguageInfo := Dictionary new.
    rowPerKey := Dictionary new.

    self addLanguage:#'de'.
    self addLanguage:#'fr'.
    self addLanguage:#'es'.
    self addLanguage:(Smalltalk language).

    "/ self initializeDemoMappings.
!

initializeDemoMappings
    keys add:'open'.
    keys add:'close'.
    keys add:'yes'.
    keys add:'no'.

    self addLanguage:#'de'.
    self addLanguage:#'fr'.

    self at:'open' language:#'de' put:'ffnen'.    
    self at:'close' language:#'de' put:'schliessen'.    
    self at:'yes' language:#'de' put:'ja'.    
    self at:'no' language:#'de' put:'nein'.    
    self at:'cancel' language:#'de' put:'abbrechen'.    

    self at:'open' language:#'fr' put:'ouvrir'.    
    self at:'close' language:#'fr' put:'fermer'.    
    self at:'yes' language:#'fr' put:'oui'.    
    self at:'no' language:#'fr' put:'non'.    
! !

!InternationalLanguageTranslationEditor::KeyStringsToLanguageMappings methodsFor:'private'!

atLanguage:lang
    ^ perLanguageMappings at:lang
!

atLanguageIndex:idx
    |lang|

    lang := languages at:idx.
    ^ self atLanguage:lang.
!

mappingAtLanguage:lang
    ^ perLanguageMappings at:lang
!

mappingAtLanguageIndex:idx
    |lang|

    lang := languages at:idx.
    ^ self mappingAtLanguage:lang.
! !

!InternationalLanguageTranslationEditor::KeyStringsToLanguageMappings methodsFor:'queries'!

includesKey:aKey
    ^ keys includes:aKey
!

includesLanguage:lang
    ^ languages includes:lang
!

indexOfKey:aKey
    ^ keys indexOf:aKey
! !

!InternationalLanguageTranslationEditor::LanguageMappingRow methodsFor:'accessing'!

atLanguage:language
    |translation|

    translation := (mappings mappingAtLanguage:language) at:key ifAbsent:nil.
    ^ translation isNil ifTrue:nil ifFalse:[translation printString]
!

columnAt:columnNr
    ^ (mappings mappingAtLanguageIndex:columnNr-1) at: key ifAbsent:nil
!

key:something
    key := something.
!

keyString
    ^ key printString
!

mappings:something
    mappings := something.
! !

!InternationalLanguageTranslationEditor::UISpecVisitor methodsFor:'accessing'!

translatedLabels
    ^ translatedLabels ? #()
! !

!InternationalLanguageTranslationEditor::UISpecVisitor methodsFor:'visiting'!

visitObject:anObject with:aParameter
    |l|

    (anObject isKindOf:UISpecification) ifTrue:[
        (anObject respondsTo:#translateLabel) ifTrue:[
            anObject translateLabel == true ifTrue:[
                translatedLabels isNil ifTrue:[
                    translatedLabels := Set new.
                ].
                l := anObject perform:#label ifNotUnderstood:nil.
                l notNil ifTrue:[
                    translatedLabels add:l.
                ].
            ].
        ].
    ].
    self visitChildrenOf:anObject.
! !

!InternationalLanguageTranslationEditor class methodsFor:'documentation'!

version
    ^ '$Header$'
! !
